
import modelo.*;
import vistas.*;


import javax.swing.UIManager;
import java.awt.*;

public class InicioAgenda {
  boolean packFrame = false;

  //Construir la aplicacin
  public InicioAgenda() {

    //Creamos un controlador
    Controlador controlador = new Controlador();

    //Conectamos la GUI con el controlador de la aplicacin
    GUIAgenda frame = new GUIAgenda(controlador);

    //Validar marcos que tienen tamaos preestablecidos
    //Empaquetar marcos que cuentan con informacin de tamao preferente til. Ej. de su diseo.
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Centrar la ventana
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  //Mtodo Main
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new InicioAgenda();
  }
}
