package vistas;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.io.*;
import modelo.*;
import javax.swing.border.*;

//Clases necesarias para la mscara del campo de texto
import javax.swing.text.MaskFormatter;
import java.text.ParseException;


public class DialogoAlta extends JDialog {

  //Necesitamos que la ventana conozca el controlador de la aplicacin
  Controlador controlador;
  String rutaFoto;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanelBotones = new JPanel();
  JButton jButtonAceptar = new JButton();
  JButton jButtonCancelar = new JButton();
  JButton jButtonBuscar = new JButton();
  JPanel jPanelDatos = new JPanel();
  JLabel jLabelNombre = new JLabel();
  JTextField jTextFieldNombre = new JTextField();
  JLabel jLabelTelefono = new JLabel();
  JFormattedTextField jFormattedTextFieldTelefono = new JFormattedTextField();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  JPanel jPanelContenedor = new JPanel();
  FlowLayout flowLayout3 = new FlowLayout();

  PanelFoto jPanelFoto = new PanelFoto();

  MaskFormatter mascaraTfno;

  public DialogoAlta (Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

//Si no le pasamos el contacto queremos DAR DE ALTA uno nuevo
  public DialogoAlta (Controlador controlador){
    this(null, "Nuevo Contacto", true);
    this.controlador= controlador;
    rutaFoto = null;
  }

//Si le pasamos un contacto es que queremos CONSULTAR ese contacto

  public DialogoAlta (Controlador controlador, Contacto c){
    this(controlador);
    inicializar(c);
  }

  public DialogoAlta () {
    this(null, "", false);
  }

  private void inicializar (Contacto c){
    jTextFieldNombre.setText(c.getNombre());
    jFormattedTextFieldTelefono.setText(c.getTfno());
    String foto = c.getFoto();
    if (foto != null) jPanelFoto.setImagen(foto);
    jButtonAceptar.setEnabled(false);
    jButtonBuscar.setEnabled(false);
    jButtonCancelar.setText("OK");
  }


  private void jbInit() throws Exception {

    this.setResizable(false);
    this.setSize(250, 250);
    this.getContentPane().setLayout(borderLayout1);

    jButtonAceptar.setText("Aceptar");
    jButtonAceptar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonAceptar_actionPerformed(e);
      }
    });
    jButtonCancelar.setText("Cancelar");
    jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonCancelar_actionPerformed(e);
      }
    });
    jButtonBuscar.setDoubleBuffered(false);
    jButtonBuscar.setText("Foto ...");
    jButtonBuscar.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButtonBuscar_actionPerformed(e);
      }
    });
    jLabelNombre.setText("Nombre");
    jTextFieldNombre.setColumns(16);

    jLabelTelefono.setText("Telfono");
    jFormattedTextFieldTelefono.setColumns(11);

    jFormattedTextFieldTelefono.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        jFormattedTextFieldTelefono_keyPressed(e);
      }
    });

    jPanelDatos.setPreferredSize(new Dimension(250, 100));
    jPanelDatos.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    flowLayout1.setHgap(20);
    flowLayout1.setVgap(15);

    jPanelBotones.setLayout(flowLayout2);
    flowLayout2.setHgap(10);
    flowLayout2.setVgap(10);

    jPanelContenedor.setLayout(flowLayout3);
    jPanelFoto.setBackground(Color.white);
    jPanelFoto.setPreferredSize(new Dimension(100, 100));

    this.getContentPane().add(jPanelBotones, BorderLayout.SOUTH);

    jPanelBotones.add(jButtonAceptar, null);
    jPanelBotones.add(jButtonCancelar, null);
    jPanelBotones.add(jButtonBuscar, null);
    jPanelDatos.add(jLabelNombre, null);
    jPanelDatos.add(jTextFieldNombre, null);
    jPanelDatos.add(jLabelTelefono, null);
    jPanelDatos.add(jFormattedTextFieldTelefono, null);
    this.getContentPane().add(jPanelContenedor,  BorderLayout.CENTER);
    jPanelContenedor.add(jPanelFoto, null);
    this.getContentPane().add(jPanelDatos, BorderLayout.NORTH);

    //Definicin de la mscara del nmero de tfno
    //Definicin de la mscara del campo de texto
    mascaraTfno = new MaskFormatter("(###)######");
    mascaraTfno.install(jFormattedTextFieldTelefono);
    mascaraTfno.setAllowsInvalid(false);

  }

  void jButtonAceptar_actionPerformed(ActionEvent e) {
    //Recogemos los datos introducidos en la pantalla
    String nombre = jTextFieldNombre.getText();
    String tfno = null;
    try{
     //Pedimos a la mscara que valide la entrada del usuario
        tfno = (String) mascaraTfno.stringToValue(jFormattedTextFieldTelefono.getText());
    }catch (ParseException pe){
      //Si el telfono no tiene el formato adecuado salta una excepcin
      JOptionPane.showMessageDialog(null,"Telefono no vlido","ERROR",JOptionPane.ERROR_MESSAGE);
      return;
    }
    controlador.nuevoContacto(nombre, tfno, rutaFoto);

    JOptionPane.showMessageDialog(this, "Ha introducido un nuevo contacto en la agenda");

    this.dispose();
  }

  void jButtonBuscar_actionPerformed(ActionEvent e) {
    JFileChooser chooser = new JFileChooser();
    chooser.setCurrentDirectory(new File("."));
    int opcion = chooser.showOpenDialog(this);
    if (opcion == JFileChooser.APPROVE_OPTION){
      rutaFoto = chooser.getSelectedFile().getAbsolutePath();
      jPanelFoto.setImagen(rutaFoto);
    }
  }

  void jButtonCancelar_actionPerformed(ActionEvent e) {
    this.dispose();
  }


  void jFormattedTextFieldTelefono_keyPressed(KeyEvent e) {

    //Dar a enter equivale a dar al botn aceptar
    if (e.getKeyCode() == KeyEvent.VK_ENTER)
      // Le damos el mismo tratamiento que al evento "Aceptar"
      jButtonAceptar_actionPerformed(null);


  }
}
