package vistas;

import java.awt.*;
import javax.swing.*;

public class PanelFoto extends JPanel {

  private Image foto = null;

  public PanelFoto() {
 }

   /**Redefinimos el mtodo paintComponent para que se redibuje
    * el panel convenientemente cuando se oculta con otra ventana,
    * se redimensiona el panel, se minimiza, ...
    */

   public void paintComponent(Graphics g){

    //Primero hacemos el comportamiento por defecto
     super.paintComponent(g);

     //Calculamos el tamao del panel
     int ancho = this.getWidth();
     int alto = this.getHeight();

     if (foto == null) {

       g.setColor(Color.red);
       g.drawLine(0, 0, ancho, alto);
       g.drawLine(0, alto, ancho, 0);

     } else {
       g.drawImage(foto, 0, 0, ancho, alto, null);
     }
  }

  /**
   *  Dibuja la imagen que se encuentra en el fichero que se le
   *  pasa como parmetro
   */

  public void setImagen(String ruta){

     cargarImagen(ruta);

     //Calculamos el tamao del panel
     int ancho = this.getWidth();
     int alto = this.getHeight();

     Graphics g = this.getGraphics();
     g.drawImage(foto, 0, 0, ancho, alto, null);
   }


   private void cargarImagen(String rutaFoto){

    Toolkit kit = Toolkit.getDefaultToolkit();
    foto = kit.getImage(rutaFoto);
    MediaTracker tracker = new MediaTracker(this);
    tracker.addImage(foto, 0); //0 = identificador
    try {
      tracker.waitForID(0);
      //o bien tracker.waitForAll();
    }
    catch (InterruptedException e) {}
   }
}
